program cdcomp;

uses os2base, os2def;

type
  Buf = array [0..127] of longint;

var
  drive : string;
  image : string;
  f : longint;
  g : file;
  pad, rc, actual : longint;
  buffer1, buffer2 : Buf;
  block : longint;
  ok : boolean;


function Mismatch (b1, b2 : Buf) : boolean;

var
  i : integer;

begin

  Mismatch := true;
  for i := 0 to 127 do
    if b1 [i] <> b2 [i] then
      exit;
  Mismatch := false

end;


begin

  writeln ('CDCOMP/2 - Copyright (c) 2000 by Vadim Rumyantsev');

  if ParamCount <> 2 then begin
    writeln ('Usage:  CDCOMP d: image');
    halt (16)
  end;

  drive := ParamStr(1) + #0;
  image := ParamStr(2);

  rc := DosOpen (@drive[1], f, pad, 0, 0, OPEN_ACTION_OPEN_IF_EXISTS,
        OPEN_FLAGS_DASD or OPEN_SHARE_DENYNONE or OPEN_ACCESS_READONLY, nil);

  if rc <> 0 then begin
    writeln ('DosOpen failed on ', drive, ' with code ', rc);
    halt (8)
  end;

  FileMode := $40;
  assign (g, image);
  reset (g, 1);

  block := 0;
  ok := true;

  while (ok and (DosRead (f, buffer1, 512, actual) = 0) and
         (actual > 0)) do begin
    blockread (g, buffer2, actual);
    if Mismatch (buffer1, buffer2) then begin
      writeln ('Mismatch at block ', block, #7#7#7);
      ok := false;
    end;
    inc (block);
    if (block div 2048 * 2048) = block then
      writeln ('... compared ', block div 2048, ' Mbytes');
  end;

  close (g);
  DosClose (f);

  if ok then
    writeln ('Compare successful!'#7)

end.
