program cdcopy;

uses os2base, os2def;

var
  drive : string;
  image : string;
  f : longint;
  g : file;
  pad, rc, actual : longint;
  buffer : array [0..511] of byte;
  total : longint;
  totsc : longint;


begin

  writeln ('CDCOPY/2 - Copyright (c) 2000 by Vadim Rumyantsev');

  if ParamCount <> 2 then begin
    writeln ('Usage:  CDCOPY d: image');
    halt (16)
  end;

  drive := ParamStr(1) + #0;
  image := ParamStr(2);

  rc := DosOpen (@drive[1], f, pad, 0, 0, OPEN_ACTION_OPEN_IF_EXISTS,
        OPEN_FLAGS_DASD or OPEN_SHARE_DENYNONE or OPEN_ACCESS_READONLY, nil);

  if rc <> 0 then begin
    writeln ('DosOpen failed on ', drive, ' with code ', rc);
    halt (8)
  end;

  assign (g, image);
  rewrite (g, 1);

  total := 0;

  repeat
    rc := DosRead (f, buffer, 512, actual);
    if rc <> 0 then begin
      writeln ('DosRead error ', rc, #7#7#7);
      break
    end;
    if actual = 0 then
      break;
    inc (total, actual);
    blockwrite (g, buffer, actual)
  until (false);

  close (g);
  DosClose (f);

  totsc := total div 2048;
  if (total mod 2048) <> 0 then
    inc (totsc);

  writeln ('Total ', total, ' bytes, ', totsc, ' 2K-blocks.');
  writeln ('Done.'#7)

end.
